<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Barcode and QR Code Animation</title>
    <style>
        #circle-center {
            position: relative;
            width: 0;
            height: 0;
            left: 50%;
            top: 90%; /* Change here */
            transform: translate(-50%, -50%);
        }

        .barcode-container {
            position: absolute;
        }

        .barcode {
            position: absolute;
            left: 50%;
            top: 50%;
            transform: translate(-50%, -50%);
        }
    </style>
    <script src="https://cdn.jsdelivr.net/npm/jsbarcode@3.11.5/dist/JsBarcode.all.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/qrcode-generator@1.4.4/qrcode.min.js"></script>
</head>
<body>
    <h1>Barcode and QR Code Animation</h1>
    <label for="code-type">Code type:</label>
    <select id="code-type">
        <option value="JAN13">JAN13</option>
        <option value="CODE39">CODE39</option>
        <option value="QR">QR Code</option>
    </select>
    <br />
    <label for="barcode-data">Barcode data:</label>
    <input type="text" id="barcode-data" value="data" /> <!-- Add here -->
    <br />
    <br />
    <label for="speed">Move speed (degrees/sec):</label>
    <input type="range" id="speed" name="speed" min="1" max="360" value="60" />
    <span id="speed-value">60</span> degrees/sec
    <br />
    <br />
    <label for="radius">Circle size:</label>
    <input type="range" id="radius" name="radius" min="100" max="500" value="200" />
    <span id="radius-value">200</span> px
    <br />
    <br />
    <div id="circle-center">
        <div class="barcode-container" id="container1">
            <img class="barcode" id="barcode1" />
        </div>
        <div class="barcode-container" id="container2">
            <img class="barcode" id="barcode2" />
        </div>
        <div class="barcode-container" id="container3">
            <img class="barcode" id="barcode3" />
        </div>
        <div class="barcode-container" id="container4">
            <img class="barcode" id="barcode4" />
        </div>
    </div>

    <script>
        document.oncontextmenu = function () {return false;}
        const barcodeContainers = [
            document.getElementById('container1'),
            document.getElementById('container2'),
            document.getElementById('container3'),
            document.getElementById('container4')
        ];

        const barcodes = [
            document.getElementById('barcode1'),
            document.getElementById('barcode2'),
            document.getElementById('barcode3'),
            document.getElementById('barcode4')
        ];

        const codeType = document.getElementById('code-type');
        const barcodeData = document.getElementById('barcode-data'); // Add here
        const speedInput = document.getElementById('speed');
        const speedValue = document.getElementById('speed-value');
        const radiusInput = document.getElementById('radius');
        const radiusValue = document.getElementById('radius-value');
        let rotationAngle = 0;
        let speed = speedInput.value * 3;
        let radius = radiusInput.value; // Add here

        function generateCode() {
            const inputData = barcodeData.value; // Add here

            for (let i = 0; i < barcodes.length; i++) {
                if (codeType.value === 'QR') {
                    const qr = qrcode(0, 'L');

                    qr.addData(inputData+i); // Change here
                    qr.make();
                    barcodes[i].src = qr.createDataURL(2);
                    barcodes[i].style.height = '100px';
                    barcodes[i].style.width = '100px';
                } 

                else {
                    JsBarcode(barcodes[i], inputData+i, { // Change here
                        format: "CODE39",
                        displayValue: false,
                        width: 2,
                        height: 100
                    });
                }
            }
        }

        function updatePosition() {
            for (let i = 0; i < barcodeContainers.length; i++) {
                const angleOffset = (360 / barcodeContainers.length) * i;
                const rad = ((rotationAngle + angleOffset) * Math.PI) / 180;
                const x = radius * Math.cos(rad);
                const y = radius * Math.sin(rad);
                barcodeContainers[i].style.left = `${x}px`;
                barcodeContainers[i].style.top = `${y}px`;
            }
        }

        function animate() {
            rotationAngle += speed / 60;
            updatePosition();
            setTimeout(animate, 1000 / 60);
        }

        barcodeData.addEventListener('input', () => { // Add here
            generateCode();
        });

        speedInput.addEventListener('input', () => {
            speed = speedInput.value * 3;
            speedValue.textContent = speed;
        });

        radiusInput.addEventListener('input', () => { // Add here
            radius = radiusInput.value;
            radiusValue.textContent = radius;
            updatePosition();
        });

        codeType.addEventListener('change', () => {
            generateCode();
        });

        generateCode();
        updatePosition();
        animate();
    </script>
</body>
</html>
